<?php
require_once '/var/www/thewoice/woice/protected/config/system.php';
require_once '/var/www/lemiecurerepository/class/protected/class.secure.php';
global $_SECURE;
class Database
{
    var $host;
    var $password;
    var $user;
    var $database;
    var $link;
    var $query;
    var $result;
    var $rows;
    var $ins_id;
    var $b_debugmode;

    function Database($db_ip = false, $db_user = false, $db_password = false, $nomedatabase = false)
    {
        global $_SECURE;
        $this->host = ($db_ip ? $db_ip : "localhost");
        $this->password = "?HhwSi_F6Yt5";
        $this->user = ($db_user ? $db_user : "thewoice");
        if(!$nomedatabase){
            $this->database = "repository_lemiecure";
        }
        else
            $this->database = $nomedatabase;

        $this->rows = 0;
        $this->ins_id = 0;
        $this->b_debugmode = 1; // IN PRODUZIONE METTERE A 0 - IN SVILUPPO E TEST METTERE A 1
        $this->OpenLink();
        $_SECURE = new secure($this->link);
    }

    function OpenLink()
    {
        $this->link = mysqli_connect($this->host, $this->user, $this->password) or die (print "Class Database: Error while connecting to DB (link)");
    }

    function SelectDB()
    {
        @mysqli_select_db($this->link, $this->database) or die (print "Class Database: Error while selecting DB");
    }

    function CloseDB()
    {
        mysqli_close($this->link);
    }

    function Query($query)
    {
        $this->SelectDB();
        $this->query = $query;
        $this->result = mysqli_query($this->link, $query);
        if (strlen(mysqli_error($this->link))) {
            $message = '<b>Invalid query:</b><br>' . mysqli_error($this->link) . '<br><br>';
            $message .= '<b>Whole query:</b><br>' . $query . '<br><br>';
            $mysqlnd = function_exists('mysqli_fetch_all');
            if ($mysqlnd) {
                if ($this->b_debugmode) {
                    die($message);
                } else {
                    $this->raise_error('db_query_error: ' . $message);
                }
            }
        } else {
            if (preg_match("/SELECT/i", $query))
                $this->rows = mysqli_num_rows($this->result);
            if (preg_match("/INSERT/i", $query))
                $this->ins_id = mysqli_insert_id($this->link);
            if (preg_match("/UPDATE/i", $query))
                return true;
        }
    }

    function raise_error($message)
    {
        $serror = "Env:       " . $_SERVER['SERVER_NAME'] . "<br/>" .
            "timestamp: " . Date('m/d/Y H:i:s') . "<br/>" .
            "script:    " . $_SERVER['PHP_SELF'] . "<br/>" .
            "error:     " . $message . "<br/>";
        $dominio_xid_wc = $_SERVER['SERVER_NAME'];
        sendMail($dominio_xid_wc, "sergioreale@artematica.it", "Error #database", $serror . '<pre>' . print_r($_SESSION, 1) . '</pre>', 3);
        die(header("Location: /ops.php"));
    }

    function mySqliConnectForDummies($basedati = false)
    {
        $host = "localhost";
        $user = "thewoice";
        $pass = "?HhwSi_F6Yt5";//screening
        if (!$basedati) {
            $basedati = 'repository_lemiecure';
        }
        $conn = mysqli_connect($host, $user, $pass, $basedati) or die($basedati . " errore nella connessione a MySql inc_open_db: " . mysqli_error());
        return $conn;
    }

    function preparedQuery($sql, $params,$fetch=0,$iteration=0) // fetch se 0 array, se 1 object || iteration se 0 ritorna risultato ciclato, se 1 ritorna risultato da ciclare
    {

        $mysqlnd = function_exists('mysqli_fetch_all');
        if (!$mysqlnd) {
            foreach ($params as $param) {
                foreach ($param as $k => $v) {
                    if ($k == 's')
                        $replaceWith = "'" . $v . "'";
                    else
                        $replaceWith = $v;
                    $sql = preg_replace('/\?/', $replaceWith, $sql, 1);
                }

            }
            $queryType = explode(" ", trim($sql));
            $queryType = strtolower($queryType[0]);
            switch ($queryType) {
                case "select":
                    $conn1 = self::mySqliConnectForDummies();
                    $result = mysqli_query($conn1, $sql);
                    $arr = array();
                    $row = mysqli_fetch_array($result);

                    while ($row = mysqli_fetch_array($result)) {
                        $new_single_row = array();
                        foreach ($row as $k => $v) {
                            if (!intval($k)) {
                                if (!is_numeric($k)) {
                                    $new_single_row[$k] = $v;
                                }
                            }
                        }
                        $arr[] = $new_single_row;
                    }
                    $a_data = $arr;
                    break;
                case "insert":
                    self::query($sql);
                    $a_data[] = $this->ins_id;
                    break;
                case "update":

                    break;
                case "delete":
                    break;
            }
            if (count($a_data) > 0) {
                if (count($a_data) == 1) {
                    return $a_data[0];
                } else {
                    return $a_data;
                }
            } else {
                return false;
            }
        }
        else {
            $this->SelectDB();
            $varTypes = "";
            $paramsList = array();
            $a_data = array();
            $queryType = strtolower(substr($sql, 0, 6));
            foreach ($params as $param) {
                $varTypes .= key($param);
            }
            $paramsList[] = &$varTypes;
            foreach ($params as $key => $param) {
                ${"var" . $key} = current($param);
                $paramsList[] = &${"var" . $key};
            }
            $stmt = $this->link->prepare($sql);
            if ($stmt === false) {
                trigger_error('Errore SQL: ' . $sql . ' Errore: ' . $this->link->errno . ' ' . $this->link->error, E_USER_ERROR);
            }
            call_user_func_array(array($stmt, "bind_param"), $paramsList);
            $queryResult = $stmt->execute();
            switch ($queryType) {
                case "select":
                    $res = $stmt->get_result();
                    if ($res){
                        if ($iteration){
                            $arr = $res;
                        }
                        else {
                            if(!$fetch){
                                $arr = mysqli_fetch_array($res);
                            }else{
                                $arr = mysqli_fetch_object($res);
                            }
                        }

                        array_push($a_data, $arr);

                    }




                    break;
                case "insert":
                    $a_data[] = $stmt->insert_id;
                    $this->ins_id = $stmt->insert_id;
                    break;
                case "update":

                case "delete":
                    $a_data[] = $queryResult;
                    break;
            }

            if (count($a_data) > 0) {
                if (count($a_data) == 1) {
                    return $a_data[0];
                } else {
                    return $a_data;
                }
            } else {
                return false;
            }
        }
    }
}
?>
