<?php
    class secure {
        
        protected $_link;
        protected $_find;
        protected $_replace;
        protected $_var;
        
        function secure($link){
            $this->_link = $link;
            $this->_find = array('\n','\r','\t','\p','script');
            $this->_replace = array('','','','','blocked');
            array_walk($_GET, array($this,"secureSuperGlobalGET"));
            array_walk($_POST, array($this,"secureSuperGlobalPOST"));
            array_walk($_REQUEST, array($this,"secureSuperGlobalREQUEST"));
        }
        
        function initLocal(&$var) { 
            $this->_var = $var;
            array_walk($this->_var, array($this,"secureSuperGlobalLocal"));
            $var = $this->_var;
        }
        
        function secureSuperGlobalGET(&$value, $key){
            $_GET[$key] = preg_replace_deep('/\s+/',' ',$_GET[$key]);
            $_GET[$key] = stripslashes_deep($_GET[$key]);
            $_GET[$key] = str_ireplace($this->_find,$this->_replace,$_GET[$key]);
             $_GET[$key] = mysqli_real_escape_deep($this->_link,$_GET[$key]);
            return $_GET[$key];
        }
       
        function secureSuperGlobalPOST(&$value, $key){
            $_POST[$key] = preg_replace_deep('/\s\s+/',' ',$_POST[$key]);
            $_POST[$key] = stripslashes_deep($_POST[$key]);
            $_POST[$key] = str_ireplace($this->_find,$this->_replace,$_POST[$key]);
            $_POST[$key] = mysqli_real_escape_deep($this->_link,$_POST[$key]);
            return $_POST[$key];
        }
        
        function secureSuperGlobalREQUEST(&$value, $key){
            $_REQUEST[$key] = preg_replace_deep('/\s\s+/',' ',$_REQUEST[$key]);
            $_REQUEST[$key] = stripslashes_deep($_REQUEST[$key]);
            $_REQUEST[$key] = str_ireplace($this->_find,$this->_replace,$_REQUEST[$key]);
            $_REQUEST[$key] = mysqli_real_escape_deep($this->_link,$_REQUEST[$key]);
            return $_REQUEST[$key];
        }
        
        function secureSuperGlobalLocal(&$value, $key){
            $this->_var[$key] = preg_replace_deep('/\s\s+/',' ',$this->_var[$key]);
            $this->_var[$key] = stripslashes_deep($this->_var[$key]);
            $this->_var[$key] = str_ireplace($this->_find,$this->_replace,$this->_var[$key]);
            $this->_var[$key] = mysqli_real_escape_deep($this->_link,$this->_var[$key]);
            return $this->_var[$key];
        }


    }
